GDAL-VECTOR-CONVERT(1)

NAME
gdal-vector-convert - Convert a vector dataset

Added in version 3.11.

SYNOPSIS

            Usage: gdal vector convert [OPTIONS] <INPUT> <OUTPUT>

            Convert a vector dataset.

            Positional arguments:
              -i, --input <INPUT>                                  Input vector datasets [required]
              -o, --output <OUTPUT>                                Output vector dataset [required]

            Common Options:
              -h, --help                                           Display help message and exit
              --json-usage                                         Display usage as JSON document and exit
              --config <KEY>=<VALUE>                               Configuration option [may be repeated]
              -q, --quiet                                          Quiet mode (no progress bar)

            Options:
              -l, --layer, --input-layer <INPUT-LAYER>             Input layer name(s) [may be repeated]
              -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed)
              --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated]
              --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated]
              --overwrite                                          Whether overwriting existing output is allowed
              --update                                             Whether to open existing dataset in update mode
              --overwrite-layer                                    Whether overwriting existing output is allowed
              --append                                             Whether appending to existing layer is allowed
                                                                   Mutually exclusive with --upsert
              --output-layer <OUTPUT-LAYER>                        Output layer name
              --skip-errors                                        Skip errors when writing features

            Advanced Options:
              --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated]
              --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated]
              --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated]
              --upsert                                             Upsert features (implies 'append')
                                                                   Mutually exclusive with --append

DESCRIPTION

gdal vector convert can be used to convert data data between different formats.

The following options are available:

  Standard options

    -f, --of, --format, --output-format <OUTPUT-FORMAT>
        Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

    --co, --creation-option <NAME>=<VALUE>
        Many formats have one or more optional dataset creation options that can be used to control particulars about the file created. For instance, the GeoPackage driver supports creation options to control the version.

        May be repeated.

        The dataset creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

        Note that dataset creation options are different from layer creation options.

    --lco, --layer-creation-option <NAME>=<VALUE>
        Many formats have one or more optional layer creation options that can be used to control particulars about the layer created. For instance, the GeoPackage driver supports layer creation options to control the feature identifier or geometry column name, setting the identifier or description, etc.

        May be repeated.

        The layer creation options available vary by format driver, and some simple formats have no layer creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

        Note that layer creation options are different from dataset creation options.

    --overwrite
        Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

    --update
        Whether the output dataset must be opened in update mode. Implies that it already exists. This mode is useful when adding new layer(s) to an already existing dataset.

    --overwrite-layer
        Whether overwriting existing layer(s) is allowed.

    --append
        Whether appending features to existing layer(s) is allowed

    -l, --layer <LAYER>
        Name of one or more layers to inspect. If no layer names are passed, then all layers will be selected.

    --output-layer <OUTPUT-LAYER>
        Output layer name. Can only be used to rename a layer, if there is a single input layer.

    --skip-errors
        Added in version 3.12.

        Whether failures to write feature(s) should be ignored. Note that this option sets the size of the transaction unit to one feature at a time, which may cause severe slowdown when inserting into databases.

  Advanced options

    --oo, --open-option <NAME>=<VALUE>
        Dataset open option (format specific).

        May be repeated.

    --output-open-option, --output-oo <NAME>=<VALUE>
        Added in version 3.12.

        Dataset open option for output dataset (format specific).

        May be repeated.

    --if, --input-format <format>
        Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

        May be repeated.

    --upsert
        Added in version 3.12.

        Variant of --append where the OGRLayer::UpsertFeature() operation is used to insert or update features instead of appending with OGRLayer::CreateFeature().

        This is currently implemented only in a few drivers: GPKG -- GeoPackage vector, Elasticsearch: Geographically Encoded Objects for Elasticsearch and MongoDBv3 (drivers that implement upsert expose the GDAL_DCAP_UPSERT capability).

        The upsert operation uses the FID of the input feature, when it is set (and the FID column name is not the empty string), as the key to update existing features. It is crucial to make sure that the FID in the source and target layers are consistent.

        For the GPKG driver, it is also possible to upsert features whose FID is unset or non-significant (the --unset-fid option of gdal vector edit can be used to ignore the FID from the source feature), when there is a UNIQUE column that is not the integer primary key.

EXAMPLES

  Example 1: Converting file poly.shp to a GeoPackage

            $ gdal vector convert poly.shp output.gpkg

  Example 2: Add new layer from file line.shp to an existing GeoPackage, and rename it "lines"

            $ gdal vector convert --update --output-layer=lines line.shp output.gpkg

  Example 3: Append features from from file poly2.shp to an existing layer poly of a GeoPackage, without a progress bar

            $ gdal vector convert --quiet --append --output-layer=poly poly2.shp output.gpkg

AUTHOR
Even Rouault <even.rouault@spatialys.com>

COPYRIGHT
1998-2026